/*************************************************************************************
*	irrlamb - http://irrlamb.googlecode.com
*	Copyright (C) 2010  Alan Witkowski
*
*	This program is free software: you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation, either version 3 of the License, or
*	(at your option) any later version.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program.  If not, see <http://www.gnu.org/licenses/>.
**************************************************************************************/
#ifndef CAMPAIGN_H
#define CAMPAIGN_H

// Libraries
#include <irrlicht/irrlicht.h>
#include "singleton.h"

// Namespaces
using namespace irr;
using namespace core;
using namespace scene;
using namespace video;
using namespace io;
using namespace gui;

// Structures
struct LevelStruct {
	stringc File, Icon;
	int Unlocked;
};

struct CampaignStruct {
	stringw Name;
	array<LevelStruct> Levels;
};

// Classes
class CampaignClass {

	public:

		int Init();
		int Close();

		const array<CampaignStruct> &GetCampaigns() const { return Campaigns; }
		const CampaignStruct &GetCampaign(int Index) const { return Campaigns[Index]; }

		const stringc &GetLevel(int Campaign, int Level) const { return Campaigns[Campaign].Levels[Level].File; }
		int GetLevelCount(int Campaign) const { return Campaigns[Campaign].Levels.size(); }

	private:

		array<CampaignStruct> Campaigns;
};

// Singletons
typedef SingletonClass<CampaignClass> Campaign;

#endif
