/*************************************************************************************
*	irrlamb - http://irrlamb.googlecode.com
*	Copyright (C) 2010  Alan Witkowski
*
*	This program is free software: you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation, either version 3 of the License, or
*	(at your option) any later version.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program.  If not, see <http://www.gnu.org/licenses/>.
**************************************************************************************/
#ifndef CONFIG_H
#define CONFIG_H

// Libraries
#include <irrlicht/irrlicht.h>
#include "singleton.h"
#include "actiontypes.h"

// Namespaces
using namespace irr;
using namespace core;
using namespace scene;
using namespace video;
using namespace io;
using namespace gui;

// Classes
class ConfigClass {

	public:

		int Init();
		int Close();

		void Reset();
		int ReadConfig();
		int WriteConfig();

		// Video
		E_DRIVER_TYPE DriverType;
		int ScreenWidth, ScreenHeight;
		bool Fullscreen;
		bool Shadows;
		bool TrilinearFiltering;
		int AnisotropicFiltering;
		int AntiAliasing;		

		// Audio
		int AudioEnabled;
		float SoundVolume, MusicVolume;

		// Input
		EKEY_CODE Keys[ACTIONS::COUNT];
		float MouseScaleX, MouseScaleY;

		// Networking
		u16 ServerPort;

		// Replays
		float ReplayInterval;
	
	private:

};

// Singletons
typedef SingletonClass<ConfigClass> Config;

#endif
