/*************************************************************************************
*	irrlamb - http://irrlamb.googlecode.com
*	Copyright (C) 2010  Alan Witkowski
*
*	This program is free software: you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation, either version 3 of the License, or
*	(at your option) any later version.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program.  If not, see <http://www.gnu.org/licenses/>.
**************************************************************************************/
#include "grapple.h"
#include "../engine/globals.h"
#include "../engine/physics.h"
#include "player.h"
#include "template.h"

// Constructor
GrappleClass::GrappleClass(const SpawnStruct &Object)
:	GrappleParentObject(NULL) {
/*
	// Graphics
	Node = irrScene->addSphereSceneNode(Object.Radius, 32);
	if(Object.Texture != "")
		Node->setMaterialTexture(0, irrDriver->getTexture(Object.Texture.c_str()));
	Node->setMaterialType(EMT_TRANSPARENT_ADD_COLOR);

	// Particle system
	IParticleSystemSceneNode *ParticleSystem = irrScene->addParticleSystemSceneNode(false, Node);

	// Create the emitter
	IParticleEmitter *Emitter = ParticleSystem->createBoxEmitter(
		aabbox3df(-0.1f, -0.05f, -0.1f, 0.1f, 0.05f, 0.1f), 
		vector3df(0.0f, 0.0005f, 0.0f),
		60, 80,
		SColor(0, 100, 20, 165), video::SColor(0, 100, 20, 165),
		1000, 1000);
	Emitter->setMinStartSize(dimension2d<f32>(0.25f, 0.25f));
	Emitter->setMaxStartSize(dimension2d<f32>(0.25f, 0.25f));
	ParticleSystem->setEmitter(Emitter);
	Emitter->drop();

	// Make the particles fade out
	IParticleAffector *ParticleAffector = ParticleSystem->createFadeOutParticleAffector();
	ParticleSystem->addAffector(ParticleAffector);
	ParticleAffector->drop();

	// Set materials
	ParticleSystem->setMaterialFlag(EMF_LIGHTING, false);
	ParticleSystem->setMaterialFlag(EMF_ZBUFFER, false);
	ParticleSystem->setMaterialTexture(0, irrDriver->getTexture("textures/fire0.png"));
	ParticleSystem->setMaterialType(EMT_TRANSPARENT_VERTEX_ALPHA);

	if(Physics::Instance().IsEnabled()) {
		
		// Orientation
		btTransform Transform;
		Physics::Instance().GetBulletTransform(Transform, Object.Position, Object.Rotation);
		MotionState = new btDefaultMotionState(Transform);
		
		// Create shape
		Shape = new btSphereShape(Object.Radius);

		btVector3 LocalInertia;
		Shape->calculateLocalInertia(Object.Mass, LocalInertia);

		RigidBody = new btRigidBody(Object.Mass, MotionState, Shape, LocalInertia);
		RigidBody->setUserPointer((void *)this);

		Physics::Instance().GetWorld()->addRigidBody(RigidBody, PhysicsClass::FILTER_GRAPPLE, PhysicsClass::FILTER_BASICBODIES);
		
	}

	SetProperties(Object);
	*/
}

// Destructor
GrappleClass::~GrappleClass() {

	Node->remove();
}

// Collision callback
void GrappleClass::HandleCollision(ObjectClass *TOtherObject, const btPersistentManifold *TContactManifold, float TNormalScale) {
	
	ObjectClass::HandleCollision(TOtherObject, TContactManifold, TNormalScale);

	// Check for grapple tips
	if(GrappleParentObject && TOtherObject->IsHookable()) {
		GrappleParentObject->GrappleTipHit(this, (ObjectClass *)(TOtherObject));
		GrappleParentObject = NULL;
	}
}

// Sets the parent object of the grapple tip
void GrappleClass::SetGrappleParent(PlayerClass *Object) {
	GrappleParentObject = Object;
}
