/*************************************************************************************
*	irrlamb - http://irrlamb.googlecode.com
*	Copyright (C) 2010  Alan Witkowski
*
*	This program is free software: you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation, either version 3 of the License, or
*	(at your option) any later version.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program.  If not, see <http://www.gnu.org/licenses/>.
**************************************************************************************/
#ifndef TEMPLATE_H
#define TEMPLATE_H

// Libraries
#include <irrlicht/irrlicht.h>
#include <bullet/btBulletDynamicsCommon.h>

// Forward Declarations
class ObjectClass;

// Namespaces
using namespace irr;
using namespace core;
using namespace scene;
using namespace video;
using namespace io;
using namespace gui;
using namespace std;

// Structures
struct TemplateStruct {
	TemplateStruct();

	// Generic properties
	int TemplateID;
	stringc Name;
	int Type;
	float Lifetime;
	
	// Collision
	stringc CollisionCallback;
	int CollisionGroup, CollisionMask;

	// Physical properties
	stringc CollisionFile;
	btVector3 Shape;
	float Radius;
	float Mass, Friction, Restitution;
	float LinearDamping, AngularDamping;

	// Constraints
	btVector3 ConstraintData[4];

	// Graphics
	stringc Mesh;
	float Scale;
	stringc Textures[4];

	// Zones
	bool Active;
};

struct SpawnStruct {
	SpawnStruct();

	stringc Name;
	btVector3 Position, Rotation;
	TemplateStruct *Template;
};

struct ConstraintStruct {
	ConstraintStruct();

	stringc Name;
	ObjectClass *BodyA, *BodyB;
	TemplateStruct *Template;
};

#endif
