/*************************************************************************************
*	irrlamb - http://irrlamb.googlecode.com
*	Copyright (C) 2010  Alan Witkowski
*
*	This program is free software: you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation, either version 3 of the License, or
*	(at your option) any later version.
*
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program.  If not, see <http://www.gnu.org/licenses/>.
**************************************************************************************/
#ifndef ZONE_H
#define ZONE_H

// Libraries
#include "object.h"

// Keeps track of touched objects
struct ObjectTouchState {
	ObjectTouchState() { }
	ObjectTouchState(ObjectClass *Object, int TouchCount) : Object(Object), TouchCount(TouchCount) { }

	ObjectClass *Object;
	int TouchCount;
};

// Classes
class ZoneClass : public ObjectClass {

	public:

		ZoneClass(const SpawnStruct &Object);

		void EndFrame();
		virtual void HandleCollision(ObjectClass *OtherObject, const btPersistentManifold *ContactManifold, float NormalScale);

		void SetActive(bool Value);

	private:

		// Attributes
		bool Active;

		// Touch state
		list<ObjectTouchState> TouchState;

};

#endif
